/* application.c generated by valac 0.34.4, the Vala compiler
 * generated from application.vala, do not modify */

/* vim: set tabstop=8 softtabstop=2 shiftwidth=2 expandtab: */
/*
 *    Copyright (C) 2011 Fabian Deutsch
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "settings.h"
#include "ui.h"
#include <libnotify/notify.h>
#include "library.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>


#define TYPE_APP_PRESENCE (app_presence_get_type ())
#define APP_PRESENCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_PRESENCE, AppPresence))
#define APP_PRESENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_PRESENCE, AppPresenceClass))
#define IS_APP_PRESENCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_PRESENCE))
#define IS_APP_PRESENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_PRESENCE))
#define APP_PRESENCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_PRESENCE, AppPresenceClass))

typedef struct _AppPresence AppPresence;
typedef struct _AppPresenceClass AppPresenceClass;
typedef struct _AppPresencePrivate AppPresencePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AppPresence {
	GObject parent_instance;
	AppPresencePrivate * priv;
};

struct _AppPresenceClass {
	GObjectClass parent_class;
};

struct _AppPresencePrivate {
	ApplicationSettings* settings;
	MainClientWindow* main_window;
	NotifyNotification* notice;
	PresenceLibPresence* provider;
};


static gpointer app_presence_parent_class = NULL;
static gchar* app_presence_uri;
static gchar* app_presence_uri = NULL;
static gboolean app_presence_is_server;
static gboolean app_presence_is_server = FALSE;
static gboolean app_presence_is_publisher;
static gboolean app_presence_is_publisher = FALSE;
static gboolean app_presence_is_not_decorated;
static gboolean app_presence_is_not_decorated = FALSE;
static gboolean app_presence_is_ipv6;
static gboolean app_presence_is_ipv6 = FALSE;
static gdouble app_presence_video_scale_factor;
static gdouble app_presence_video_scale_factor = 0.5;
static gdouble app_presence_video_quality_factor;
static gdouble app_presence_video_quality_factor = 0.7;
static gdouble app_presence_video_fps_factor;
static gdouble app_presence_video_fps_factor = 0.5;
static gboolean app_presence_is_debug;
static gboolean app_presence_is_debug = FALSE;
static gboolean app_presence_use_advanced_video_preferences;
static gboolean app_presence_use_advanced_video_preferences = FALSE;

GType app_presence_get_type (void) G_GNUC_CONST;
#define APP_PRESENCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_APP_PRESENCE, AppPresencePrivate))
enum  {
	APP_PRESENCE_DUMMY_PROPERTY
};
AppPresence* app_presence_new (void);
AppPresence* app_presence_construct (GType object_type);
void app_presence_init (AppPresence* self, gchar*** args, int* args_length1);
static void app_presence_parse_options (AppPresence* self, gchar*** args, int* args_length1);
static void app_presence_init_ui (AppPresence* self, gchar** args, int args_length1);
static void app_presence_bind_lib_to_ui (AppPresence* self);
static void app_presence_apply_settings (AppPresence* self);
static void __lambda4_ (AppPresence* self, const gchar* s);
static void ___lambda4__presence_lib_presence_peers_discovered (PresenceLibPresence* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self);
static void __lambda5_ (AppPresence* self, const gchar* s);
static void ___lambda5__presence_lib_presence_peers_lost (PresenceLibPresence* _sender, const gchar* uri, gpointer self);
void app_presence_run (AppPresence* self);
static void app_presence_finalize (GObject* obj);

static const GOptionEntry APP_PRESENCE_options[11] = {{"uri", 'u', 0, G_OPTION_ARG_STRING, &app_presence_uri, "The RTSP URI to connect to.", "rtsp://127.0.0.1:8554/test"}, {"server", 's', 0, G_OPTION_ARG_NONE, &app_presence_is_server, "Provide an RSTP stream for the first device.", NULL}, {"publish", 'p', 0, G_OPTION_ARG_NONE, &app_presence_is_publisher, "Publish any RTSP stream.", NULL}, {"without-window-decorations", (gchar) 0, 0, G_OPTION_ARG_NONE, &app_presence_is_not_decorated, "Hide window decorations.", NULL}, {"ipv6", '6', 0, G_OPTION_ARG_NONE, &app_presence_is_ipv6, "Use IPv6.", NULL}, {"video-scale-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_scale_factor, "Factor used to scale the video (0-1).", NULL}, {"video-quality-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_quality_factor, "Factor used to set the compression quality of video (0-1).", NULL}, {"video-fps-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_fps_factor, "Factor used to set the FPS of the video (0-1).", NULL}, {"debug", 'd', 0, G_OPTION_ARG_NONE, &app_presence_is_debug, "Output some debugging informations.", NULL}, {"advanced-video-preferences", (gchar) 0, 0, G_OPTION_ARG_NONE, &app_presence_use_advanced_video_preferences, "If more advanced video preferences should be presented.", NULL}, {NULL}};

AppPresence* app_presence_construct (GType object_type) {
	AppPresence * self = NULL;
	ApplicationSettings* _tmp0_ = NULL;
	ApplicationSettings* _tmp1_ = NULL;
	PresenceLibPresence* _tmp2_ = NULL;
#line 58 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self = (AppPresence*) g_object_new (object_type, NULL);
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = application_settings_new ();
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->settings);
#line 60 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self->priv->settings = _tmp0_;
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->settings;
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = presence_lib_presence_new_with_settings (_tmp1_);
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->provider);
#line 61 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self->priv->provider = _tmp2_;
#line 58 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	return self;
#line 135 "application.c"
}


AppPresence* app_presence_new (void) {
#line 58 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	return app_presence_construct (TYPE_APP_PRESENCE);
#line 142 "application.c"
}


void app_presence_init (AppPresence* self, gchar*** args, int* args_length1) {
	PresenceLibPresence* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 65 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	app_presence_parse_options (self, args, args_length1);
#line 69 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = self->priv->provider;
#line 69 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	presence_lib_presence_init (_tmp0_, args, args_length1);
#line 71 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = *args;
#line 71 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1__length1 = *args_length1;
#line 71 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	app_presence_init_ui (self, _tmp1_, _tmp1__length1);
#line 73 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	app_presence_bind_lib_to_ui (self);
#line 75 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	app_presence_apply_settings (self);
#line 168 "application.c"
}


static void app_presence_parse_options (AppPresence* self, gchar*** args, int* args_length1) {
	ApplicationSettings* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 178 "application.c"
	{
		GOptionContext* opt_context = NULL;
		GOptionContext* _tmp0_ = NULL;
		GOptionContext* _tmp1_ = NULL;
		GOptionContext* _tmp2_ = NULL;
		GOptionContext* _tmp3_ = NULL;
#line 81 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp0_ = g_option_context_new ("- Show presence");
#line 81 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		opt_context = _tmp0_;
#line 82 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp1_ = opt_context;
#line 82 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_option_context_set_help_enabled (_tmp1_, TRUE);
#line 83 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp2_ = opt_context;
#line 83 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_option_context_add_main_entries (_tmp2_, APP_PRESENCE_options, NULL);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp3_ = opt_context;
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_option_context_parse (_tmp3_, args_length1, args, &_inner_error_);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			_g_option_context_free0 (opt_context);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			if (_inner_error_->domain == G_OPTION_ERROR) {
#line 207 "application.c"
				goto __catch0_g_option_error;
			}
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			_g_option_context_free0 (opt_context);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			g_clear_error (&_inner_error_);
#line 84 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
			return;
#line 218 "application.c"
		}
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_g_option_context_free0 (opt_context);
#line 222 "application.c"
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		FILE* _tmp7_ = NULL;
		gchar** _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
		const gchar* _tmp9_ = NULL;
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		e = _inner_error_;
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp4_ = stdout;
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp5_ = e;
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp6_ = _tmp5_->message;
#line 86 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		fprintf (_tmp4_, "%s\n", _tmp6_);
#line 87 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp7_ = stdout;
#line 87 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp8_ = *args;
#line 87 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp8__length1 = *args_length1;
#line 87 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp9_ = _tmp8_[0];
#line 87 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		fprintf (_tmp7_, "Run '%s --help' to see a full list of available command line options.\n", _tmp9_);
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_g_error_free0 (e);
#line 88 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		return;
#line 261 "application.c"
	}
	__finally0:
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		return;
#line 272 "application.c"
	}
#line 92 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp10_ = self->priv->settings;
#line 92 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp11_ = app_presence_is_debug;
#line 92 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_debug (_tmp10_, _tmp11_);
#line 280 "application.c"
}


static void app_presence_init_ui (AppPresence* self, gchar** args, int args_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	ApplicationSettings* _tmp1_ = NULL;
	MainClientWindow* _tmp2_ = NULL;
	MainClientWindow* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 95 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	notify_init ("presence");
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = args;
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0__length1 = args_length1;
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->settings;
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = main_client_window_new (_tmp0_, _tmp0__length1, _tmp1_);
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 99 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self->priv->main_window = _tmp2_;
#line 100 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp3_ = self->priv->main_window;
#line 100 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp4_ = app_presence_is_not_decorated;
#line 100 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	main_client_window_set_decorated (_tmp3_, !_tmp4_);
#line 313 "application.c"
}


static void __lambda4_ (AppPresence* self, const gchar* s) {
	NotifyNotification* _tmp0_ = NULL;
	NotifyNotification* _tmp1_ = NULL;
	MainClientWindow* _tmp2_ = NULL;
	PresenceLibPresence* _tmp3_ = NULL;
	GHashTable* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (s != NULL);
#line 106 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = notify_notification_new ("New peers were discovered.", "Presence discovered new peers. Use the peers dialog to connect to one " \
"of them.", "face-glasses");
#line 106 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->notice);
#line 106 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self->priv->notice = _tmp0_;
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->notice;
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	notify_notification_show (_tmp1_, &_inner_error_);
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		return;
#line 345 "application.c"
	}
#line 109 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = self->priv->main_window;
#line 109 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp3_ = self->priv->provider;
#line 109 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp4_ = presence_lib_presence_get_peers (_tmp3_);
#line 109 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp5_ = _tmp4_;
#line 109 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	main_client_window_set_peers (_tmp2_, _tmp5_);
#line 357 "application.c"
}


static void ___lambda4__presence_lib_presence_peers_discovered (PresenceLibPresence* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self) {
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	__lambda4_ ((AppPresence*) self, name);
#line 364 "application.c"
}


static void __lambda5_ (AppPresence* self, const gchar* s) {
	MainClientWindow* _tmp0_ = NULL;
	PresenceLibPresence* _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (s != NULL);
#line 113 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_debug ("application.vala:113: Updating peers (rm).");
#line 115 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = self->priv->main_window;
#line 115 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->provider;
#line 115 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = presence_lib_presence_get_peers (_tmp1_);
#line 115 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp3_ = _tmp2_;
#line 115 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	main_client_window_set_peers (_tmp0_, _tmp3_);
#line 387 "application.c"
}


static void ___lambda5__presence_lib_presence_peers_lost (PresenceLibPresence* _sender, const gchar* uri, gpointer self) {
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	__lambda5_ ((AppPresence*) self, uri);
#line 394 "application.c"
}


static void app_presence_bind_lib_to_ui (AppPresence* self) {
	PresenceLibPresence* _tmp0_ = NULL;
	PresenceLibPresence* _tmp1_ = NULL;
	PresenceLibPresence* _tmp2_ = NULL;
	MainClientWindow* _tmp3_ = NULL;
#line 103 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = self->priv->provider;
#line 105 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_signal_connect_object (_tmp0_, "peers-discovered", (GCallback) ___lambda4__presence_lib_presence_peers_discovered, self, 0);
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->provider;
#line 111 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_signal_connect_object (_tmp1_, "peers-lost", (GCallback) ___lambda5__presence_lib_presence_peers_lost, self, 0);
#line 118 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = self->priv->provider;
#line 118 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp3_ = self->priv->main_window;
#line 118 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp2_, "rtsp-address", (GObject*) _tmp3_, "rtsp-address", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
#line 419 "application.c"
}


static void app_presence_apply_settings (AppPresence* self) {
	ApplicationSettings* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	ApplicationSettings* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	ApplicationSettings* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	ApplicationSettings* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	ApplicationSettings* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	ApplicationSettings* _tmp17_ = NULL;
	gdouble _tmp18_ = 0.0;
	ApplicationSettings* _tmp19_ = NULL;
	gdouble _tmp20_ = 0.0;
	ApplicationSettings* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
#line 122 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = self->priv->settings;
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = app_presence_is_server;
#line 124 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_rtsp_server_enabled (_tmp0_, _tmp1_);
#line 125 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp2_ = self->priv->settings;
#line 125 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp3_ = app_presence_is_ipv6;
#line 125 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_ipv6 (_tmp2_, _tmp3_);
#line 126 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp4_ = app_presence_uri;
#line 126 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	if (_tmp4_ != NULL) {
#line 462 "application.c"
		ApplicationSettings* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		ApplicationSettings* _tmp7_ = NULL;
#line 128 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp5_ = self->priv->settings;
#line 128 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp6_ = app_presence_uri;
#line 128 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		application_settings_set_rtsp_client_uri (_tmp5_, _tmp6_);
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		_tmp7_ = self->priv->settings;
#line 129 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
		application_settings_set_rtsp_client_enabled (_tmp7_, TRUE);
#line 476 "application.c"
	}
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp8_ = self->priv->settings;
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp9_ = g_get_user_name ();
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp10_ = g_get_host_name ();
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp11_ = g_strdup_printf ("%s@%s", _tmp9_, _tmp10_);
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp12_ = _tmp11_;
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_mdns_name (_tmp8_, _tmp12_);
#line 132 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_free0 (_tmp12_);
#line 136 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp13_ = self->priv->settings;
#line 136 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp14_ = app_presence_is_publisher;
#line 136 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_mdns_enabled (_tmp13_, _tmp14_);
#line 138 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp15_ = self->priv->settings;
#line 138 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp16_ = app_presence_video_scale_factor;
#line 138 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_video_scale_factor (_tmp15_, _tmp16_);
#line 139 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp17_ = self->priv->settings;
#line 139 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp18_ = app_presence_video_quality_factor;
#line 139 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_video_quality_factor (_tmp17_, _tmp18_);
#line 140 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp19_ = self->priv->settings;
#line 140 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp20_ = app_presence_video_fps_factor;
#line 140 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_video_fps_factor (_tmp19_, _tmp20_);
#line 142 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp21_ = self->priv->settings;
#line 142 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp22_ = app_presence_use_advanced_video_preferences;
#line 142 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	application_settings_set_use_advanced_video_preferences_dialog (_tmp21_, _tmp22_);
#line 522 "application.c"
}


void app_presence_run (AppPresence* self) {
	MainClientWindow* _tmp0_ = NULL;
	MainClientWindow* _tmp1_ = NULL;
#line 146 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_return_if_fail (self != NULL);
#line 148 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp0_ = self->priv->main_window;
#line 148 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	main_client_window_show (_tmp0_);
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_tmp1_ = self->priv->main_window;
#line 149 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	main_client_window_run (_tmp1_);
#line 539 "application.c"
}


static void app_presence_class_init (AppPresenceClass * klass) {
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	app_presence_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	g_type_class_add_private (klass, sizeof (AppPresencePrivate));
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = app_presence_finalize;
#line 550 "application.c"
}


static void app_presence_instance_init (AppPresence * self) {
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self->priv = APP_PRESENCE_GET_PRIVATE (self);
#line 557 "application.c"
}


static void app_presence_finalize (GObject* obj) {
	AppPresence * self;
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_PRESENCE, AppPresence);
#line 51 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->settings);
#line 53 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 54 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->notice);
#line 56 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	_g_object_unref0 (self->priv->provider);
#line 22 "/builddir/build/BUILD/presence-0.4.8/src/application.vala"
	G_OBJECT_CLASS (app_presence_parent_class)->finalize (obj);
#line 575 "application.c"
}


GType app_presence_get_type (void) {
	static volatile gsize app_presence_type_id__volatile = 0;
	if (g_once_init_enter (&app_presence_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppPresenceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_presence_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppPresence), 0, (GInstanceInitFunc) app_presence_instance_init, NULL };
		GType app_presence_type_id;
		app_presence_type_id = g_type_register_static (G_TYPE_OBJECT, "AppPresence", &g_define_type_info, 0);
		g_once_init_leave (&app_presence_type_id__volatile, app_presence_type_id);
	}
	return app_presence_type_id__volatile;
}



